#include<fcntl.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<esd.h>

#define BUF_SIZE 64000

int main(int argc, char* argv[])
{
  int fd, stream, esd_id;
  char buf[BUF_SIZE];
  int result;

  esd_id = esd_open_sound("pulsation.gmurf.fr:5001");
  printf("%d\n",esd_id);

  if (argc != 2)
    {
      printf("Syntax: ./TestEsdSocket esd_server_name\n");
      exit(-1);
    }

  stream = esd_play_stream(ESD_BITS16 | ESD_STEREO | ESD_STREAM | ESD_PLAY, 44100, "pulsation.gmurf.fr:5001", "lilith");

  printf("%d\n", stream);

  fd = open("../gui/Gmurf.wav",O_RDONLY);
  if (fd < 0)
    {
      printf("Can't open test file ;(\n");
      exit(-2);
    }

  while ((result = read(fd, buf, BUF_SIZE)) > 0)
    write(stream, buf);
  
  close(fd);
  esd_close(stream);

}
