#include "Menu.h"
#include "Select.h"
#include "xpms/options.xpm"
#include "xpms/save.xpm"
#include "xpms/quit.xpm"
#include "xpms/open.xpm"
#include "xpms/filez.xpm"
#include "xpms/help.xpm"
#include "xpms/about.xpm"
#include "xpms/cut.xpm"
#include "xpms/copy.xpm"
#include "xpms/paste.xpm"
#include "xpms/edit.xpm"
#include "xpms/filter.xpm"
#include "xpms/render.xpm"
#include "xpms/open_proj.xpm"
#include "xpms/save_proj.xpm"
#include "xpms/undo.xpm"
#include "xpms/redo.xpm"

void		new_wav(void) ;
GtkWidget 	*create_edit_menu(Wavwin *ww) ;
void		swap_wave(GtkWidget	*widget) ;
void		cut_wave(GtkWidget	*widget) ;
void		copy_wave(GtkWidget	*widget) ;
void		paste_wave(GtkWidget	*widget) ;
void		erase_wave(GtkWidget	*widget) ;
void            undo_wave(GtkWidget     *widget) ;
void            redo_wave(GtkWidget     *widget) ;


ITEM	Root_File_Menu[RFMIN] = 
{
  {"Open Wave",		NULL,			open_xpm},
  {"New Wave",		new_wav,		open_xpm},
  {"Open Project",	want_you_open_project,	open_proj_xpm},
  {"Save Project",	File_Save_Project,	save_proj_xpm},
  {"Render Project",	File_Render_Project,	render_xpm},
  {"Quit Gmurf",	quit,			quit_xpm}
};

ITEM 	Open_File_Menu[NB_OPEN] =
{
  {"Open in WE",	open_in_WE,		open_xpm},
  {"Open in Mixer",	open_in_MIX,		open_xpm},
  {"Open in both",	open_in_BOTH,		open_xpm}
} ;

ITEM  Wav_File_Menu[WFMIN] = 
{
  {"Restore",	NULL,		open_xpm},
  {"Save",	NULL,		save_xpm},
  {"Save as",	File_Save_Wave,	save_xpm},
  {"Options",	NULL,		options_xpm},
  {"Close",	close_ww,	quit_xpm}
} ; 

ITEM    Edit_File_Menu[] =
{
  {"Undo",              undo_wave,              undo_xpm},
  {"Redo",              redo_wave,              redo_xpm},
  {"Cut",               cut_wave,               cut_xpm},
  {"Copy",              copy_wave,              copy_xpm},
  {"Paste",             paste_wave,             paste_xpm},
  {"Swap",              swap_wave,              copy_xpm},
  {"Erase",             erase_wave,             cut_xpm}
} ;


ITEM  Wav_Help_Menu[WHMIN] = 
{
  {"About", NULL, about_xpm}
} ;

GtkWidget 	*create_open_menu	(void) ;
GtkWidget	*Create_filter_menu	(t_filters	*filter,
					 Wavwin		*ww) ;
GtkWidget	*Create_filter_submenu	(t_filter 	*filter,
					 unsigned int	nbr_filt ,
					 char		*cat_name ,
					 Wavwin		*ww) ;
void		gui_launch_filter	(GtkWidget	*widget,
					 gpointer	data) ;

void		destroy_data (widget,
			      data)
GtkWidget	*widget ;
gpointer	data ;
{
  gtk_widget_destroy(GTK_WIDGET(data)) ;
}

GtkWidget *create_root_menu_bar(void)
{
  GtkWidget	*menu_bar ;
  GtkWidget	*menu_item ;
  GtkWidget	*main_menu ; 
  GtkWidget	*hbox1 ; 
  GtkWidget	*label ;
  int		i;

  menu_bar = gtk_menu_bar_new();
  gtk_widget_show(menu_bar);
  /* Creation du sous menu de File */

  main_menu = gtk_menu_new();
  gtk_menu_append(GTK_MENU (main_menu), create_open_menu());
  for (i=1; i<RFMIN; i++)
    {
      menu_item = gtk_menu_item_new();
      gtk_widget_set_name(main_menu, "root menu");
      label = gtk_label_new(Root_File_Menu[i].name);
      gtk_widget_show (label);
      hbox1 = gtk_hbox_new (FALSE, 0);
      gtk_box_pack_start(GTK_BOX (hbox1), 
			 new_pix_from_data (MainWindow, 
					    Root_File_Menu[i].pix),
			 FALSE,FALSE,1);
      gtk_box_pack_start(GTK_BOX (hbox1), label, FALSE, FALSE, 0);
      gtk_signal_connect(GTK_OBJECT (menu_item), "activate" ,
			 GTK_SIGNAL_FUNC (Root_File_Menu[i].func), NULL) ;
      gtk_widget_show (hbox1);
      gtk_container_add (GTK_CONTAINER (menu_item), hbox1);
      gtk_menu_append (GTK_MENU (main_menu), menu_item);
      gtk_widget_show (menu_item);
    };
  
  /* creation de l'item File */

  menu_item = gtk_menu_item_new();
  label = gtk_label_new("File");
  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start(GTK_BOX (hbox1), 
		     new_pix_from_data (MainWindow, (char **)filez_xpm),
		     FALSE,FALSE,1);
  gtk_box_pack_start(GTK_BOX (hbox1), label, FALSE, FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (menu_item), hbox1);
  gtk_widget_show (label);
  gtk_widget_show (menu_item);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_item), main_menu);
  gtk_menu_bar_append (GTK_MENU_BAR (menu_bar), menu_item);
  return menu_bar ;  
}


GtkWidget *create_open_menu(void)
{
  GtkWidget	*menu_item ;
  GtkWidget	*main_menu ; 
  GtkWidget	*hbox1 ; 
  GtkWidget	*label ;
  int		i;
 
  main_menu = gtk_menu_new();
  for (i=0; i<NB_OPEN; i++)
    {
      menu_item = gtk_menu_item_new();
      label = gtk_label_new(Open_File_Menu[i].name);
      gtk_widget_show (label);
      hbox1 = gtk_hbox_new (FALSE, 0);
      gtk_box_pack_start(GTK_BOX (hbox1), 
			 new_pix_from_data (MainWindow, 
					    Open_File_Menu[i].pix),
			 FALSE,FALSE,1);
      gtk_box_pack_start(GTK_BOX (hbox1), label, FALSE, FALSE, 0);
      gtk_signal_connect(GTK_OBJECT (menu_item), "activate" ,
			 GTK_SIGNAL_FUNC (Open_File_Menu[i].func), NULL) ;
      gtk_widget_show (hbox1);
      gtk_container_add (GTK_CONTAINER (menu_item), hbox1);
      gtk_menu_append (GTK_MENU (main_menu), menu_item);
      gtk_widget_show (menu_item);
    };
  
  /* creation de l'item File */

  menu_item = gtk_menu_item_new();
  label = gtk_label_new("Open");
  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start(GTK_BOX (hbox1), 
		     new_pix_from_data (MainWindow, (char **)open_xpm),
		     FALSE,FALSE,0);
  gtk_box_pack_start(GTK_BOX (hbox1), label, FALSE, FALSE, 1);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (menu_item), hbox1);
  gtk_widget_show (label);
  gtk_widget_show (menu_item);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_item), main_menu);
  return menu_item ;  
}


void		create_wav_menu_bar(ww,
				    window)
Wavwin		*ww ;
GtkWidget	*window ;
{
  GtkWidget	*menu_item ;
  GtkWidget	*main_menu ;
  GtkWidget	*hbox1 ;
  GtkWidget	*label ;
  int		i;

             /* Creation du sous menu de File */

  main_menu = gtk_menu_new();
  for (i=0; i<WFMIN; i++)
    {
      menu_item = gtk_menu_item_new();
      label = gtk_label_new(Wav_File_Menu[i].name);
      gtk_widget_show (label);
      
      hbox1 = gtk_hbox_new (FALSE, 0);
      gtk_box_pack_start(GTK_BOX (hbox1), 
			 new_pix_from_data (MainWindow, 
					    Wav_File_Menu[i].pix),
			 FALSE,FALSE,1);
      gtk_box_pack_start(GTK_BOX (hbox1), label, FALSE, FALSE, 0);
      gtk_signal_connect_object(GTK_OBJECT (menu_item), "activate" ,
				GTK_SIGNAL_FUNC (Wav_File_Menu[i].func), 
				GTK_OBJECT(ww)) ;
      gtk_widget_show (hbox1);
      gtk_container_add (GTK_CONTAINER (menu_item), hbox1);
      
      gtk_menu_append (GTK_MENU (main_menu), menu_item);
      gtk_widget_show (menu_item);
    };
  
  /* creation de l'item File */

  menu_item = gtk_menu_item_new();
  label = gtk_label_new("File");
  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start(GTK_BOX (hbox1), 
		     new_pix_from_data (MainWindow, (char **)filez_xpm),
		     FALSE,FALSE,1);
  gtk_box_pack_start(GTK_BOX (hbox1), label, FALSE, FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (menu_item), hbox1);
  gtk_widget_show (label);
  gtk_widget_show (menu_item);
 
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_item), main_menu);
  gtk_menu_bar_append (GTK_MENU_BAR (ww->menubar), menu_item);


  	  /* Creation du sous menu de Help */

  main_menu = gtk_menu_new();
  for (i=0; i<WHMIN; i++)
    {
      menu_item = gtk_menu_item_new();
      label = gtk_label_new(Wav_Help_Menu[i].name);
      gtk_widget_show (label);
      
      hbox1 = gtk_hbox_new (FALSE, 0);
      gtk_box_pack_start(GTK_BOX (hbox1), 
			 new_pix_from_data (MainWindow, 
					    Wav_Help_Menu[i].pix),
			 FALSE,FALSE,1);
      gtk_box_pack_start(GTK_BOX (hbox1), label, FALSE, FALSE, 0);
      gtk_signal_connect(GTK_OBJECT (menu_item), "activate" ,
			 GTK_SIGNAL_FUNC (Wav_Help_Menu[i].func), NULL) ;
      gtk_widget_show (hbox1);
      gtk_container_add (GTK_CONTAINER (menu_item), hbox1);
      
      gtk_menu_append (GTK_MENU (main_menu), menu_item);
      gtk_widget_show (menu_item);
    };
  
  /* creation de l'item Help */

  menu_item = gtk_menu_item_new();
  label = gtk_label_new("Help");
  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start(GTK_BOX (hbox1), 
		     new_pix_from_data (MainWindow, (char **)help_xpm),
		     FALSE,FALSE,1);
  gtk_box_pack_start(GTK_BOX (hbox1), label, FALSE, FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (menu_item), hbox1);
  gtk_widget_show (label);
  gtk_widget_show (menu_item);
 
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_item), main_menu);

  gtk_menu_bar_append (GTK_MENU_BAR (ww->menubar), create_edit_menu(ww)) ;
  gtk_menu_bar_append (GTK_MENU_BAR (ww->menubar), 
		       Create_filter_menu(MIXER (Global_Mixer)->filters, ww)) ;
  gtk_menu_bar_append (GTK_MENU_BAR (ww->menubar), menu_item);
  
}


GtkWidget	*Create_filter_menu(filter, ww)
t_filters	*filter ;
Wavwin		*ww;
{
  GtkWidget 	*label ;
  GtkWidget 	*menu ;
  GtkWidget	*menu_item ;
  t_category	*cat ;
  int		i ;
  GtkWidget	*hbox ;
  
  menu = gtk_menu_new() ;

  cat = filter->category ;
  for (i=0 ; i < filter->nb_category ; i++)
  {
    gtk_menu_append (GTK_MENU (menu),
		     Create_filter_submenu(cat->filter, cat->nb_filters,
					   cat->name, ww)) ;
    cat = cat->next ;
  }

  menu_item = gtk_menu_item_new() ;
  label = gtk_label_new("Filters") ;
  gtk_widget_show (label) ;
  hbox = gtk_hbox_new(FALSE, 0) ;
  gtk_widget_show (hbox) ;
  gtk_box_pack_start(GTK_BOX (hbox), 
		     new_pix_from_data (MainWindow, (char **)filter_xpm),
		     FALSE,FALSE,1);
  gtk_box_pack_start(GTK_BOX (hbox), 
		     label,
		     FALSE,FALSE,0);
  gtk_container_add(GTK_CONTAINER (menu_item), hbox) ;
  gtk_widget_show (menu_item) ;
 
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_item), menu);

  return menu_item ;
}


GtkWidget	*Create_filter_submenu(filter, nbr_filt, cat_name, ww)
t_filter 	*filter ;
unsigned int	nbr_filt ;
char		*cat_name ;
Wavwin		*ww;
{
  GtkWidget 	*label ;
  GtkWidget 	*menu ;
  GtkWidget	*menu_item ;
  t_filter	*f_tmp ;
  int		i ;
  t_filter_need	*tfn ;
  
  f_tmp = filter ;
  menu = gtk_menu_new() ;  
  
  for (i=0 ; i < nbr_filt ; i++)
  {
    tfn = (t_filter_need *) malloc(sizeof (t_filter_need));
    tfn->ww = ww ;
    menu_item = gtk_menu_item_new();
    label = gtk_label_new(f_tmp->name);
    gtk_container_add(GTK_CONTAINER (menu_item), label) ;
    gtk_widget_show (label);
    tfn->path = f_tmp->path ;
    gtk_signal_connect(GTK_OBJECT (menu_item), "activate" ,
		       GTK_SIGNAL_FUNC (gui_launch_filter), (gpointer) tfn) ;
    gtk_menu_append (GTK_MENU (menu), menu_item);
    gtk_widget_show (menu_item);
    f_tmp = f_tmp->next ;
  }

  menu_item = gtk_menu_item_new() ;
  label = gtk_label_new(cat_name) ;
  gtk_container_add(GTK_CONTAINER (menu_item), label) ;
  gtk_widget_show(label) ;
  gtk_widget_show(menu_item) ;
 
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_item), menu);

  return menu_item ;
}


void		gui_launch_filter(widget, data)
GtkWidget	*widget ;
gpointer	data ;
{
  t_filter_need	*filt_need ;  
  t_filter_data	*filter_data ;
  int		page ;
  int		i;
  t_select	*sel;
  //Wavwin	*ww; 

  filt_need = (t_filter_need *) data ;

  filter_data = (t_filter_data	*) malloc(sizeof (t_filter_data)) ;
  page = gtk_notebook_current_page(GTK_NOTEBOOK (filt_need->ww->notebook)) ;
  filter_data->rate      = filt_need->ww->tempgmurf->sample_rate ;
  filter_data->chanel    = filt_need->ww->playmode->chanels;
  sel = create_select(WAVEDITOR(filt_need->ww->wve[STANDARD])->selection.x,
		      WAVEDITOR(filt_need->ww->wve[STANDARD])->selection.y -
		      WAVEDITOR(filt_need->ww->wve[STANDARD])->selection.x + 1,
		      filt_need->ww->invert, WAVEDITOR(filt_need->ww->wve[STANDARD])->there_is_a_selection,
		      filt_need->ww->playmode->chanels) ;
  exec_filter(filt_need->path, filter_data, filt_need->ww->tempgmurf, sel) ;
  free(sel);
  free(filter_data);

  if (filt_need->ww->tempgmurf->connected == IN_BOTH)
  {  
    if (filt_need->ww->tempgmurf->temp_size / 4 + filt_need->ww->ms_connected->begin
	> MIXER(Global_Mixer)->max_size)
    {
      t_ms_list *tmp ;
      
      MIXER(Global_Mixer)->max_size = filt_need->ww->tempgmurf->temp_size / 4 + 
	filt_need->ww->ms_connected->begin;
      tmp = MIXER(Global_Mixer)->ms_list ;
      for (i = 0 ; i < MIXER(Global_Mixer)->nb_ms ; i++)
      {
	ms_draw_wav(tmp->ms) ;
	tmp = tmp->next ;
      }
    } else 
      ms_draw_wav(filt_need->ww->ms_connected) ;
  }

  update_scroll(WAVEDITOR (filt_need->ww->wve[STANDARD]), filt_need->ww->tempgmurf) ;
  gtk_signal_emit_by_name(GTK_OBJECT (filt_need->ww->wve[STANDARD]), 
			  "channel_right_configure") ;
}


void	new_wav()
{
  char		*user ;
  char 		*tmp_dir ;
  char		*str ;
  static int 	i = 42 ;
  t_tempgmurf	*tgmf ;
  t_mixer_info	*minfo ;
  t_mixer_elt	*elt ;

  user = getenv("USER") ;
  tmp_dir = (char *) malloc(strlen(user) + strlen(TMP_GMURF_DIR) + 2) ;
  strcpy(tmp_dir, TMP_GMURF_DIR);
  strcat(tmp_dir, "_") ;
  strcat(tmp_dir, user) ;

  str = (char *) malloc(sizeof(char)* ( strlen(tmp_dir) + strlen(itoa(i)) + 6) ) ;
  strcpy(str, tmp_dir) ;
  strcat(str, "/") ;
  strcat(str, "tmp.") ;
  strcat(str, itoa(i)) ;

  tgmf = new_tempgmurf(str, NULL) ;
  minfo = new_mixer_info(DEFAULT_VOLUME, 0, DEFAULT_PANNING, DEFAULT_DATE) ;
  elt = add_mixer_elt(MIXER (Global_Mixer)->Main_Mixer,
		      MIXER (Global_Mixer)->gmurfrc->first_dsp_in_list , 
		      tgmf, minfo) ;
  tgmf->temp_size = 0 ;
  Create_mix_sample(tgmf) ;  
}

void		proto(widget)
GtkWidget	*widget ;
{
  Wavwin	*ww ;
  
  ww = WAVWIN (widget) ;
  // ww->tempgmurf ;
}

GtkWidget 	*create_edit_menu(ww)
Wavwin		*ww ;

{
  GtkWidget	*menu_item ;
  GtkWidget	*main_menu ; 
  GtkWidget	*hbox1 ; 
  GtkWidget	*label ;
  int		i;
 
  main_menu = gtk_menu_new();
  for (i=0; i < 7; i++)
    {
      menu_item = gtk_menu_item_new();
      label = gtk_label_new(Edit_File_Menu[i].name);
      gtk_widget_show (label);
      hbox1 = gtk_hbox_new (FALSE, 0);
      gtk_box_pack_start(GTK_BOX (hbox1), 
			 new_pix_from_data (MainWindow, 
					    Edit_File_Menu[i].pix),
			 FALSE,FALSE,0);
      gtk_box_pack_start(GTK_BOX (hbox1), label, FALSE, FALSE, 0);
      gtk_signal_connect_object(GTK_OBJECT (menu_item), "activate" ,
				GTK_SIGNAL_FUNC (Edit_File_Menu[i].func), 
				GTK_OBJECT (ww)) ;
      gtk_widget_show (hbox1);
      gtk_container_add (GTK_CONTAINER (menu_item), hbox1);
      gtk_menu_append (GTK_MENU (main_menu), menu_item);
      gtk_widget_show (menu_item);
    };
  
  /* creation de l'item File */

  menu_item = gtk_menu_item_new();
  label = gtk_label_new("Edit");
  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start(GTK_BOX (hbox1), 
		     new_pix_from_data (MainWindow, (char **)edit_xpm),
		     FALSE,FALSE,0);
  gtk_box_pack_start(GTK_BOX (hbox1), label, FALSE, FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (menu_item), hbox1);
  gtk_widget_show (label);
  gtk_widget_show (menu_item);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_item), main_menu);
  return menu_item ;  
}


void		cut_wave(widget)
GtkWidget	*widget ;
{
  Wavwin 	*ww ;
  t_select	*sel ;
  

  ww = WAVWIN(widget) ;
  sel = create_select(WAVEDITOR(ww->wve[STANDARD])->selection.x,
		      WAVEDITOR(ww->wve[STANDARD])->selection.y -
		      WAVEDITOR(ww->wve[STANDARD])->selection.x + 1,
		      ww->invert, WAVEDITOR(ww->wve[STANDARD])->there_is_a_selection,
		      ww->playmode->chanels) ;
  cut(ww->tempgmurf, sel) ;
  free(sel) ;
  if (ww->tempgmurf->connected == IN_BOTH)
  {  
    if (ww->tempgmurf->temp_size / 4 + ww->ms_connected->begin
	> MIXER(Global_Mixer)->max_size)
    {
      t_ms_list *tmp ;
      int	i ;
      
      MIXER(Global_Mixer)->max_size = ww->tempgmurf->temp_size / 4 + 
	ww->ms_connected->begin;
      tmp = MIXER(Global_Mixer)->ms_list ;
      for (i = 0 ; i < MIXER(Global_Mixer)->nb_ms ; i++)
      {
	ms_draw_wav(tmp->ms) ;
	tmp = tmp->next ;
      }
    } else 
      ms_draw_wav(ww->ms_connected) ;
  }
  
  update_scroll(WAVEDITOR (ww->wve[STANDARD]), ww->tempgmurf) ;
  gtk_signal_emit_by_name(GTK_OBJECT (ww->wve[STANDARD]), 
			  "channel_right_configure") ;
}


void		paste_wave(widget)
GtkWidget	*widget ;
{
  int		i;
  int		result;
  Wavwin 	*ww ;
  t_select	*sel ;
  

  ww = WAVWIN(widget) ;
  sel = create_select(WAVEDITOR(ww->wve[STANDARD])->selection.x,
		      WAVEDITOR(ww->wve[STANDARD])->selection.y -
		      WAVEDITOR(ww->wve[STANDARD])->selection.x + 1,
		      ww->invert, WAVEDITOR(ww->wve[STANDARD])->there_is_a_selection,
		      ww->playmode->chanels) ;
  result = paste(ww->tempgmurf, sel, 44100) ;
  if ((result == 0) && (sel->chanel != 2))
    {
      sel = create_select(WAVEDITOR(ww->wve[STANDARD])->selection.x,
			  WAVEDITOR(ww->wve[STANDARD])->selection.y -
			  WAVEDITOR(ww->wve[STANDARD])->selection.x + 1,
			  0, WAVEDITOR(ww->wve[STANDARD])->there_is_a_selection,
			  1 - ww->playmode->chanels) ;
      cut(ww->tempgmurf, sel) ;
    }
  free(sel) ;
  if (ww->tempgmurf->connected == IN_BOTH)
    {  
      if (ww->tempgmurf->temp_size / 4 + ww->ms_connected->begin
	  > MIXER(Global_Mixer)->max_size)
	{
	  t_ms_list *tmp ;   
	  MIXER(Global_Mixer)->max_size = ww->tempgmurf->temp_size / 4 + 
	    ww->ms_connected->begin;
	  tmp = MIXER(Global_Mixer)->ms_list ;
	  for (i = 0 ; i < MIXER(Global_Mixer)->nb_ms ; i++)
	    {
	      ms_draw_wav(tmp->ms) ;
	      tmp = tmp->next ;
	    }
	} else 
	  ms_draw_wav(ww->ms_connected) ;
    }
  update_scroll(WAVEDITOR (ww->wve[STANDARD]), ww->tempgmurf) ;
  gtk_signal_emit_by_name(GTK_OBJECT (ww->wve[STANDARD]), 
			  "channel_right_configure") ;
}



void		copy_wave(widget)
GtkWidget	*widget ;
{
  Wavwin 	*ww ;
  t_select	*sel ;
  

  ww = WAVWIN(widget) ;
  sel = create_select(WAVEDITOR(ww->wve[STANDARD])->selection.x,
		      WAVEDITOR(ww->wve[STANDARD])->selection.y -
		      WAVEDITOR(ww->wve[STANDARD])->selection.x + 1,
		      ww->invert, WAVEDITOR(ww->wve[STANDARD])->there_is_a_selection,
		      ww->playmode->chanels) ;
  copy(ww->tempgmurf, sel) ;
  free(sel) ;
  gtk_signal_emit_by_name(GTK_OBJECT (ww->wve[STANDARD]), 
			  "channel_right_configure") ;
}


void		swap_wave(widget)
GtkWidget	*widget ;
{
  Wavwin 	*ww ;
  t_select	*sel ;
  

  ww = WAVWIN(widget) ;
  sel = create_select(WAVEDITOR(ww->wve[STANDARD])->selection.x,
		      WAVEDITOR(ww->wve[STANDARD])->selection.y -
		      WAVEDITOR(ww->wve[STANDARD])->selection.x + 1,
		      ww->invert, WAVEDITOR(ww->wve[STANDARD])->there_is_a_selection,
		      ww->playmode->chanels) ;
  swap_chanels(ww->tempgmurf, sel) ;
  free(sel) ;
  gtk_signal_emit_by_name(GTK_OBJECT (ww->wve[STANDARD]), 
			  "channel_right_configure") ;
}


void		erase_wave(widget)
GtkWidget	*widget ;
{
  Wavwin 	*ww ;
  t_select	*sel ;
  

  ww = WAVWIN(widget) ;
  sel = create_select(WAVEDITOR(ww->wve[STANDARD])->selection.x,
		      WAVEDITOR(ww->wve[STANDARD])->selection.y -
		      WAVEDITOR(ww->wve[STANDARD])->selection.x + 1,
		      ww->invert, WAVEDITOR(ww->wve[STANDARD])->there_is_a_selection,
		      ww->playmode->chanels) ;
  earse(ww->tempgmurf, sel) ;
  free(sel) ;
  gtk_signal_emit_by_name(GTK_OBJECT (ww->wve[STANDARD]), 
			  "channel_right_configure") ;
}

void            undo_wave(widget)
GtkWidget       *widget ;
{
  int		i;
  Wavwin        *ww ;

  if (access(undo_file, F_OK) != -1)
    {
      ww = WAVWIN(widget) ;
      close(ww->tempgmurf->file);
      rename(ww->tempgmurf->tempname, redo_file);
      rename(undo_file, ww->tempgmurf->tempname);
      ww->tempgmurf->file = open(ww->tempgmurf->tempname, O_RDWR | O_APPEND);
      ww->tempgmurf->temp_size = give_file_size(ww->tempgmurf->file);
      if (ww->tempgmurf->connected == IN_BOTH)
	{  
	  if (ww->tempgmurf->temp_size / 4 + ww->ms_connected->begin
	      > MIXER(Global_Mixer)->max_size)
	    {
	      t_ms_list *tmp ;   
	      MIXER(Global_Mixer)->max_size = ww->tempgmurf->temp_size / 4 + 
		ww->ms_connected->begin;
	      tmp = MIXER(Global_Mixer)->ms_list ;
	      for (i = 0 ; i < MIXER(Global_Mixer)->nb_ms ; i++)
		{
		  ms_draw_wav(tmp->ms) ;
		  tmp = tmp->next ;
		}
	    } else 
	      ms_draw_wav(ww->ms_connected) ;
	}
      update_scroll(WAVEDITOR (ww->wve[STANDARD]), ww->tempgmurf) ;

      gtk_signal_emit_by_name(GTK_OBJECT (ww->wve[STANDARD]),
			      "channel_right_configure") ;
    }
}

void            redo_wave(widget)
GtkWidget       *widget ;
{
  int		i;
  Wavwin        *ww ;

  if (access(redo_file, F_OK) != -1)
    {
      ww = WAVWIN(widget) ;
      close(ww->tempgmurf->file);
      rename(ww->tempgmurf->tempname, undo_file);
      rename(redo_file, ww->tempgmurf->tempname);
      ww->tempgmurf->file = open(ww->tempgmurf->tempname, O_RDWR | O_APPEND);
      ww->tempgmurf->temp_size = give_file_size(ww->tempgmurf->file);
      if (ww->tempgmurf->connected == IN_BOTH)
	{  
	  if (ww->tempgmurf->temp_size / 4 + ww->ms_connected->begin
	      > MIXER(Global_Mixer)->max_size)
	    {
	      t_ms_list *tmp ;      
	      MIXER(Global_Mixer)->max_size = ww->tempgmurf->temp_size / 4 + 
		ww->ms_connected->begin;
	      tmp = MIXER(Global_Mixer)->ms_list ;
	      for (i = 0 ; i < MIXER(Global_Mixer)->nb_ms ; i++)
		{
	  ms_draw_wav(tmp->ms) ;
	  tmp = tmp->next ;
		}
	    } else 
	      ms_draw_wav(ww->ms_connected) ;
	}
      update_scroll(WAVEDITOR (ww->wve[STANDARD]), ww->tempgmurf) ;

      gtk_signal_emit_by_name(GTK_OBJECT (ww->wve[STANDARD]),
			      "channel_right_configure") ;
    }
}
